#!/usr/bin/perl
$LogFile = "/log.txt";
open(F,">$LogFile");
$List1 = $ARGV[0];
$List2 = $ARGV[1];
$BadSpot = $List1 . "BAD/";
$GoodSpot = $List2 . "GOOD/";

use lib ($ARGV[2]);
use Bio::Trace::ABIF;
use File::Copy;
my $abif = Bio::Trace::ABIF->new();
@FileList = <$List1*.ab1>;

foreach $CurrentFile(@FileList){
	print F "$CurrentFile\n";
	@PartsOfName = split ('/',$CurrentFile);
	$SampleName = $PartsOfName[-1];
	print F "$SampleName\n";
	$FileToCompare = "$List2" . "$SampleName";
	if (-e $FileToCompare){
		$abif->open_abif($CurrentFile);
		$NumLowQualityBases1 = $abif->num_low_quality_bases(20);
		$NumMediumQualityBases1 = $abif->num_medium_quality_bases(21,40);
		$NumHighQualityBases1 = $abif->num_high_quality_bases(41);
		$abif->close_abif();
		$abif->open_abif($FileToCompare);
		$NumLowQualityBases2 = $abif->num_low_quality_bases(20);
		$NumMediumQualityBases2 = $abif->num_medium_quality_bases(21,40);
		$NumHighQualityBases2 = $abif->num_high_quality_bases(41);
		$abif->close_abif();
		$BaseFile1 = $CurrentFile;
		$BaseFile2 = $FileToCompare;
		$BaseFile1 =~s!.ab1!!g;
		$BaseFile2 =~s!.ab1!!g;
		$Is2Better = "N";
		print F "$BaseFile1\n$BaseFile2\n\n\n";
		if ($NumHighQualityBases2 ne $NumHighQualityBases){
			if ($NumHighQualityBases2 > $NumHighQualityBases){
				$Is2Better = "Y";
			}
		}else{
			if (($NumMediumQualityBases2 + $NumMediumQualityBases) ne 0){
				if ($NumMediumQualityBases2 > $NumMediumQualityBases){
					$Is2Better = "Y";
				}
			}else{
				if ($NumLowQualityBases2 > $NumLowQualityBases){
					$Is2Better = "Y";
				}
			}
		}
		if ($Is2Better eq "Y"){
			&MoveDaFiles;
		}else{
			&MoveBadFiles;
		}
	} 
}
close (F);

sub MoveDaFiles {
	$PHD1 = $BaseFile1 . ".phd.1";
	$SEQ1 = $BaseFile1 . ".seq";
	$ABI1 = $BaseFile1 . ".ab1";
	$PHD2 = $BaseFile2 . ".phd.1";
	$SEQ2 = $BaseFile2 . ".seq";
	$ABI2 = $BaseFile2 . ".ab1";
	if (-e $PHD2){
 		move ($PHD2,$GoodSpot);
	}
	if (-e $SEQ2){
 		move ($SEQ2,$GoodSpot);
	}
	if (-e $ABI2){
 		move ($AB12,$GoodSpot);
	}
	if (-e $PHD1){
 		move ($PHD1,$BadSpot);
	}
	if (-e $SEQ1){
 		move ($SEQ1,$BadSpot);
	}
	if (-e $ABI1){
 		move ($AB11,$BadSpot);
	}
}


sub MoveBadFiles {
	$PHD1 = $BaseFile1 . ".phd.1";
	$SEQ1 = $BaseFile1 . ".seq";
	$ABI1 = $BaseFile1 . ".ab1";
	$PHD2 = $BaseFile2 . ".phd.1";
	$SEQ2 = $BaseFile2 . ".seq";
	$ABI2 = $BaseFile2 . ".ab1";
	if (-e $PHD2){
 		move ($PHD2,$BadSpot);
	}
	if (-e $SEQ2){
 		move ($SEQ2,$BadSpot);
	}
	if (-e $ABI2){
 		move ($AB12,$BadSpot);
	}
	if (-e $PHD1){
 		move ($PHD1,$GoodSpot);
	}
	if (-e $SEQ1){
 		move ($SEQ1,$GoodSpot);
	}
	if (-e $ABI1){
 		move ($AB11,$GoodSpot);
	}
}

